#include "kinematics.h"

std::vector<float> fk_circle(const float& P,const float& p,const float& deltha,const std::vector<float>& m,const std::vector<float>& beta)
{

  int                i,j,sol;
  float              sumprod,r1,r2,x,comp;
  std::vector<float> alpha;
  std::vector<float> p1,p2,p3,p4,p5,p6;
  std::vector<float> q1,q2,q3;
  std::vector<float> p41,p42,p51,p52,p61,p62;
  std::vector<float> inverseA,B,m2,l;
  std::vector<float> sum,error,rot,endefector,out;
  std::vector<float> v,u,RotMatrixP5,RotMatrixP6;
  p1.push_back(0.0);
  p1.push_back(0.0);
  p1.push_back(0.0);

  p2.push_back(P);
  p2.push_back(0.0);
  p2.push_back(0.0);

  p3.push_back(P/2.0);
  p3.push_back(sqrt(3)*P/2.0);
  p3.push_back(0.0);

  q1.push_back(deltha);
  q1.push_back(0.0);
  q1.push_back(0.0);

  q2.push_back(P-deltha/2);
  q2.push_back(deltha/2*sqrt(3));
  q2.push_back(0.0);

  q3.push_back(P/2-deltha/2);
  q3.push_back((P*sqrt(3)/2)-(deltha/2*sqrt(3)));
  q3.push_back(0.0);

  inverseA.push_back( 1.108709366063877);
  inverseA.push_back(-0.131824017241637);
  inverseA.push_back(0.025640827152264);
  inverseA.push_back(-0.003048659048141);
  inverseA.push_back(0.000592988602041);
  inverseA.push_back( -0.000070505528403);

  inverseA.push_back(-0.000126167787668);
  inverseA.push_back(1.212780958623064);
  inverseA.push_back(-0.235895609800825);
  inverseA.push_back(0.028047663242902);
  inverseA.push_back(-0.005455495138779);
  inverseA.push_back(0.000648650861307);

  inverseA.push_back(0.000592988602041);
  inverseA.push_back(-0.000070505528403);
  inverseA.push_back(1.108709366063877);
  inverseA.push_back(-0.131824017241637);   
  inverseA.push_back(0.025640827152264);  
  inverseA.push_back(-0.003048659048141);

  inverseA.push_back(-0.005455495138779);   
  inverseA.push_back(0.000648650861307);
  inverseA.push_back(-0.000126167787668);
  inverseA.push_back(1.212780958623064);
  inverseA.push_back(-0.235895609800825);
  inverseA.push_back( 0.028047663242902);

  inverseA.push_back(0.025640827152264);
  inverseA.push_back(-0.003048659048141);
  inverseA.push_back(0.000592988602041);
  inverseA.push_back(-0.000070505528403);
  inverseA.push_back(1.108709366063877);
  inverseA.push_back(-0.131824017241637);

  inverseA.push_back(-0.235895609800825);
  inverseA.push_back(0.028047663242902);
  inverseA.push_back(-0.005455495138779);
  inverseA.push_back(0.000648650861307);
  inverseA.push_back(-0.000126167787668);
  inverseA.push_back(1.212780958623064);

  B.push_back(deltha*(P-deltha));  //Deltha (P-deltha)
  B.push_back(deltha*(p-deltha));  // Deltha (p-deltha)
  B.push_back(deltha*(P-deltha));
  B.push_back(deltha*(p-deltha));
  B.push_back(deltha*(P-deltha));
  B.push_back(deltha*(p-deltha));

  sum.push_back(pow(m[0],2.0) + B[0]);
  sum.push_back(pow(m[1],2.0) + B[1]);
  sum.push_back(pow(m[2],2.0) + B[2]);
  sum.push_back(pow(m[3],2.0) + B[3]);
  sum.push_back(pow(m[4],2.0) + B[4]);
  sum.push_back(pow(m[5],2.0) + B[5]);

  for(i=0;i<6;i++){
    sumprod=0;
    for(j=0;j<6;j++){
      sumprod += inverseA[i*6+j]*sum[j];
    }
    l.push_back(sqrt(sumprod));
    //std::cout << l[i] << std::endl;
  }
  
  alpha.push_back(asin(m[0]*sin(beta[0])/l[1]));
  alpha.push_back(asin(m[2]*sin(beta[1])/l[3]));
  alpha.push_back(asin(m[4]*sin(beta[2])/l[5]));

  // Potes 1 i 2
  r1 = m[0]*cos(beta[0]);
  r2 = l[1]*cos(alpha[-0]);
  x=(pow(r1,2)-pow(r2,2)+pow((P-deltha),2))/(2*(P-deltha));

  p41.push_back(deltha+x);
  p41.push_back(-sqrt(abs(pow(r1,2)-pow(x,2))));
  p41.push_back((m[0]*sin(beta[0]))); 
  
  p42.push_back( p41[0]);
  p42.push_back(-p41[1]);
  p42.push_back(p41[2]);

 //std::cout << "p41: " << p41[0] <<" " <<p41[1] << " " << p41[2] << std::endl;
 //std::cout << "p42: " << p42[0] <<" " <<p42[1] << " " << p42[2] << std::endl;

  // Potes 3 i 4
  r1 = m[2]*cos(beta[1]);
  r2 = l[3]*cos(alpha[1]);
  x= (pow(r1,2)-pow(r2,2)+pow((P-deltha),2))/(2*(P-deltha));
  v.push_back(x);
  v.push_back(sqrt(abs(pow(r1,2)-pow(x,2)))); 
  v.push_back(0);

  RotMatrixP5.push_back(-0.5);
  RotMatrixP5.push_back(sqrt(3)/2);
  RotMatrixP5.push_back(0);
  RotMatrixP5.push_back(sqrt(3)/2);
  RotMatrixP5.push_back(0.5);
  RotMatrixP5.push_back(0);
  RotMatrixP5.push_back(0);
  RotMatrixP5.push_back(0);
  RotMatrixP5.push_back(1);
  u = addVectors(multiplyVectorMatrix(v,RotMatrixP5),q2);
  p51.push_back(u[0]);
  p51.push_back(u[1]);
  p51.push_back(m[2]*sin(beta[1]));
  v[1]=-sqrt(abs(pow(r1,2)-pow(x,2))); 
  u = addVectors(multiplyVectorMatrix(v,RotMatrixP5),q2);
  p52.push_back(u[0]);
  p52.push_back(u[1]);
  p52.push_back(p51[2]);
  v.clear();

// std::cout << "p51: " << p51[0] <<" " <<p51[1] << " " << p51[2] << std::endl;
// std::cout << "p52: " << p52[0] <<" " <<p52[1] << " " << p52[2] << std::endl;

  // Potes 5 i 6
  r1 = m[4]*cos(beta[2]);
  r2 = l[5]*cos(alpha[2]);
  x= (pow(r1,2)-pow(r2,2)+pow((P-deltha),2))/(2*(P-deltha));
  v.push_back(x);
  v.push_back(sqrt(abs(pow(r1,2)-pow(x,2)))); 
  v.push_back(0);
  RotMatrixP6.push_back(-0.5);
  RotMatrixP6.push_back(sqrt(3)/2);
  RotMatrixP6.push_back(0);
  RotMatrixP6.push_back(-sqrt(3)/2);
  RotMatrixP6.push_back(-0.5);
  RotMatrixP6.push_back(0);
  RotMatrixP6.push_back(0);
  RotMatrixP6.push_back(0);
  RotMatrixP6.push_back(1);
 u = addVectors(multiplyVectorMatrix(v,RotMatrixP6),q3);
  p61.push_back(u[0]);
  p61.push_back(u[1]);
  p61.push_back(m[4]*sin(beta[2]));
  v[1]=-sqrt(abs(pow(r1,2)-pow(x,2))); 
  u = addVectors(multiplyVectorMatrix(v,RotMatrixP6),q3);
  p62.push_back(u[0]);
  p62.push_back(u[1]);
  p62.push_back(p61[2]);
  v.clear();

// std::cout << "p61: " << p61[0] <<" " <<p61[1] << " " << p61[2] << std::endl;
// std::cout << "p62: " << p62[0] <<" " <<p62[1] << " " << p62[2] << std::endl;

  error.push_back(abs(norm(diffpoints(p51,p41))-p)+abs(norm(diffpoints(p61,p51))-p)+abs(norm(diffpoints(p41,p61))-p));
  error.push_back(abs(norm(diffpoints(p51,p41))-p)+abs(norm(diffpoints(p62,p51))-p)+abs(norm(diffpoints(p41,p62))-p));
  error.push_back(abs(norm(diffpoints(p52,p41))-p)+abs(norm(diffpoints(p61,p52))-p)+abs(norm(diffpoints(p41,p61))-p));
  error.push_back(abs(norm(diffpoints(p52,p41))-p)+abs(norm(diffpoints(p62,p52))-p)+abs(norm(diffpoints(p41,p62))-p));
  error.push_back(abs(norm(diffpoints(p51,p42))-p)+abs(norm(diffpoints(p61,p51))-p)+abs(norm(diffpoints(p42,p61))-p));
  error.push_back(abs(norm(diffpoints(p51,p42))-p)+abs(norm(diffpoints(p62,p51))-p)+abs(norm(diffpoints(p42,p62))-p));
  error.push_back(abs(norm(diffpoints(p52,p42))-p)+abs(norm(diffpoints(p61,p52))-p)+abs(norm(diffpoints(p42,p61))-p));
  error.push_back(abs(norm(diffpoints(p52,p42))-p)+abs(norm(diffpoints(p62,p52))-p)+abs(norm(diffpoints(p42,p62))-p));

  comp = error[0];
  sol = 8;
  for (i=0;i<8;i++){
    if (error[i] <= comp){
      comp = error[i];
      sol = i;
    }
  }
 // std::cout << "Sol: " << sol <<std::endl;
  if (sol == 0)       {
                        endefector = computeEndefector(p41,p51,p61,p);
                        rot = computeRot(p41,p51,p61);
                      }
  else if (sol == 1)  {
                        endefector = computeEndefector(p41,p51,p62,p);
                        rot = computeRot(p41,p51,p62);
                      }
  else if (sol == 2)  {
                        endefector = computeEndefector(p41,p52,p61,p);
                        rot = computeRot(p41,p52,p61);                      
                      }
  else if (sol == 3)  {
                        endefector = computeEndefector(p41,p52,p62,p);
                        rot = computeRot(p41,p52,p62);                      
                      }
  else if (sol == 4)  {
                        endefector = computeEndefector(p42,p51,p61,p);
                        rot = computeRot(p42,p51,p61);
                      }
  else if (sol == 5)  {
                        endefector = computeEndefector(p42,p51,p62,p);
                        rot = computeRot(p42,p51,p62);
                      }
  else if (sol == 6)  {
                        endefector = computeEndefector(p42,p52,p61,p);
                        rot = computeRot(p42,p52,p61);
                      }
  else if (sol == 7)  {
                        endefector = computeEndefector(p42,p52,p62,p);
                        rot = computeRot(p42,p52,p62);
                      }
  else std::cout<< "error in Forward Kinematics " << std::endl;
for(unsigned int i=0;i<3;i++)
 out.push_back(endefector[i]);
for(unsigned int i=0;i<9;i++)
 out.push_back(rot[i]);
return (out);
}
