#include "kinematics.h"
#include <time.h>
#include <fstream>
using namespace std;

#define dim 6

std::vector<float> fk_newton_raphson(const std::vector<float>& m,const std::vector<float>& pos,std::vector<float>& rot)
{
 float wx,wy,wz;
 unsigned int P,p,deltha;
 unsigned int max_it,it;
 float error;
 std::vector<float> d,f,X,Xpos,Xi,X6i,roti,J,Jinv(36),out;
 wx = atan2(rot[7],rot[8]);   
 wy= atan2(-rot[6],(sqrt(rot[0]*rot[0]+rot[3]*rot[3])));
 wz=  atan2(rot[3],rot[0]);
 clock_t start, end;
 double cpu_time_used;
 max_it=100;
 error= 100;
 P=102;
 p=57;
 deltha=10;
 for(unsigned int i=0;i<3;i++)
  Xi.push_back(pos[i]);
  Xi.push_back(wx);
  Xi.push_back(wy);
  Xi.push_back(wz);
 it=0;
 roti=rot;
 start = clock();
while (error > 1e-4)
{
 X=Xi;
 it=it+1; 
 rot=roti;
 ik(P,p,deltha,rot,X,f);
 for(unsigned int i=0;i<3;i++)
 Xpos.push_back(X[i]);
 J=computeJacobian (P,p,deltha,Xpos,rot);
 Xpos.clear();
 //d= J\(m-f)';
 matrix_inverse(&J[0],&Jinv[0],dim);
 //d=inv(J)*(m-f)';
 d=multiplyVectorMatrix6(diff6(f,m),Jinv);
//Xi=X+d';
 Xi=addVectors6(X,d);
 roti=matrixr3d(Xi[3]*PI/180,Xi[4]*PI/180,Xi[5]*PI/180);
 error=norm6(diff6(m,f));  
 // std::cout << error << std::endl;
 //out=[Xi(1:3) roti];
 f.clear();
 if(it>=max_it) 
  { 
  std::cout << "No ha convergit :-(" << std::endl;
  error=0;
  cpu_time_used=-1;
  }
  else if(error<=1e-4)
  {
   end = clock();
   cpu_time_used =(((float) (end - start)) / CLOCKS_PER_SEC)*1000;
  //std::cout<<"Ha convergit :-)" << std::endl;
  //std::cout << it <<" " << error << std::endl;
  }
//getchar();
}
//out.clear();
for(unsigned int i=0;i<3;i++)
 out.push_back(Xi[i]);
for(unsigned int i=0;i<9;i++)
out.push_back(roti[i]);
out.push_back(it);
out.push_back(error);
out.push_back(cpu_time_used);
return (out);
}
 
