#include "kinematics.h"

void ik(const float& P,const float& p,const float& deltha,const std::vector<float>& rotMat,const std::vector<float>& endefector,std::vector<float>& m)
{
  std::vector<float> R;
  std::vector<float> p1,p2,p3,p4,p5,p6,q1,q2,q3,q4,q5,q6;
  int                i,j;
  std::vector<float> p4aux,p5aux,p6aux,q4aux,q5aux,q6aux;
  
  p1.push_back(0.0);
  p1.push_back(0.0);
  p1.push_back(0.0);

  p2.push_back(P);
  p2.push_back(0.0);
  p2.push_back(0.0);

  p3.push_back(P/2.0);
  p3.push_back(sqrt(3)*P/2.0);
  p3.push_back(0.0);

  p4.push_back(0.0);
  p4.push_back(-sqrt(3.0)*p/3.0);
  p4.push_back(0.0);

  p5.push_back(p/2.0);
  p5.push_back(sqrt(3.0)*p/(2.0*3.0));
  p5.push_back(0);

  p6.push_back(-p/2.0)  ;
  p6.push_back(sqrt(3.0)*p/(2.0*3.0));
  p6.push_back(0.0);

  q1.push_back(deltha);
  q1.push_back(0.0);
  q1.push_back(0.0);

  q2.push_back(P-deltha/2.0);
  q2.push_back(deltha/2.0*sqrt(3.0));
  q2.push_back(0.0);

  q3.push_back(P/2.0-deltha/2.0);
  q3.push_back(P*sqrt(3.0)/2.0-deltha/2.0*sqrt(3.0));
  q3.push_back(0.0);

  q4.push_back(deltha/2.0);
  q4.push_back(-sqrt(3.0)*p/3.0+sqrt(3.0)*deltha/2.0);
  q4.push_back(0.0);

  q5.push_back(p/2.0-deltha);
  q5.push_back(sqrt(3.0)*p/(2.0*3.0));
  q5.push_back(0.0);

  q6.push_back(-p/2.0+deltha/2.0);
  q6.push_back(sqrt(3.0)*p/(2.0*3.0)-sqrt(3.0)*deltha/2.0);
  q6.push_back(0.0);

  for (i=0;i<3;i++)
  {
  p4aux.push_back(0.0);
  p5aux.push_back(0.0);
  p6aux.push_back(0.0);
  q4aux.push_back(0.0);
  q5aux.push_back(0.0);
  q6aux.push_back(0.0);
	}
  R= transposeMatrix(rotMat);

  p4aux = addVectors(multiplyVectorMatrix(p4,R),endefector);
  p5aux = addVectors(multiplyVectorMatrix(p5,R),endefector);
  p6aux = addVectors(multiplyVectorMatrix(p6,R),endefector);
  q4aux = addVectors(multiplyVectorMatrix(q4,R),endefector);
  q5aux = addVectors(multiplyVectorMatrix(q5,R),endefector);
  q6aux = addVectors(multiplyVectorMatrix(q6,R),endefector);


  p4=p4aux;
  p5=p5aux;
  p6=p6aux;
  q4=q4aux;
  q5=q5aux;
  q6=q6aux;

  m.push_back(norm(diffpoints(q1,p4)));
  m.push_back(norm(diffpoints(p2,q4)));
  m.push_back(norm(diffpoints(q2,p5)));
  m.push_back(norm(diffpoints(p3,q5)));
  m.push_back(norm(diffpoints(q3,p6)));
  m.push_back(norm(diffpoints(p1,q6)));
  
}
