#ifndef _OPERATIONS_H
#define _OPERATIONS_H
#define PI (3.141592653589793)

#include <iostream>
#include <stdio.h>
#include <math.h>
#include <vector>

float norm(const std::vector<float>& v);
float norm6(const std::vector<float>& v);
float abs(const float& num);
std::vector<float> cross(const std::vector<float>& v0,const std::vector<float>& v1);
std::vector<float> multiplyVectorMatrix( const std::vector<float>& v,const std::vector<float>& R);
std::vector<float> multiplyVectorMatrix6( const std::vector<float>& v,const std::vector<float>& R);
std::vector<float> transposeMatrix(const std::vector<float>& R);
std::vector<float> diffpoints(const std::vector<float>& p0,const std::vector<float>& p1);
std::vector<float> diff6(const std::vector<float>& p0,const std::vector<float>& p1);
std::vector<float> addVectors(const std::vector<float>& p0,const std::vector<float>& p1);
std::vector<float> addVectors6(const std::vector<float>& p0,const std::vector<float>& p1);
std::vector<float> computeEndefector(const std::vector<float>& p4,const std::vector<float>& p5,const std::vector<float>& p6,const float& p);
std::vector<float> computeRot(const std::vector<float>& p4,const std::vector<float>& p5,const std::vector<float>& p6);
void showvector(std::vector<float>& vector);
std::vector<float> computeJacobian(const float& P,const float& p,const float& deltha,const std::vector<float>& pos,const std::vector<float>& rot);
std::vector<float> multiplyVectorEscalar( const float k,const std::vector<float>& v);
void matrix_inverse(float *Min, float *Mout, int actualsize);
void showMatrix(std::vector<float>& vector,int dim);
std::vector<float> matrixr3d(float wx, float wy, float wz);
void shift(std::vector<float>& vector);
#endif
