	#ifndef _PHIDGET1049_H
#define _PHIDGET1049_H

#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <phidget21.h>

class CPHIDGET1049
{
  private: 
    CPhidgetSpatialHandle spatial;
    static int AttachHandler(CPhidgetHandle spatial, void *userptr);
    static int DetachHandler(CPhidgetHandle spatial, void *userptr);
    static int ErrorHandler(CPhidgetHandle spatial, void *userptr, int ErrorCode, const char *unknown);
  public:
    CPHIDGET1049(void);
    double Gx, Gy, Gz;
    bool attached;
    int serialNo, version;
    const char* DeviceType;
    int numAccelAxes, numGyroAxes, numCompassAxes, dataRateMax, dataRateMin;
    double angle;
    void open(int serialNo);
    int wait(int milliseconds);
    int displayProperties(void);
    static int SpatialDataHandler(CPhidgetSpatialHandle spatial, void *userptr, CPhidgetSpatial_SpatialEventDataHandle *data, int count);
    void setDataRate(int ms);
    void getAcc(void);
    void getAngle(void);
    void close(void);
   ~CPHIDGET1049(); 
};

#endif 
